import { ParserOptions, ComponentDoc } from 'react-docgen-typescript';
import { DocusaurusContext, Plugin, RouteConfig } from '@docusaurus/types';
import { CompilerOptions } from 'typescript';

type Route = Pick<RouteConfig, "exact" | "component" | "path" | "priority">;
type Union = {
    global?: undefined | false;
    route: Route;
} | {
    global: boolean;
    route?: Route;
};
type Options = Union & {
    src: string | string[];
    tsConfig?: string;
    compilerOptions?: CompilerOptions;
    parserOptions?: ParserOptions;
    globOptions: null;
};
declare function plugin(context: DocusaurusContext, { src, global, route, tsConfig, compilerOptions, parserOptions, }: Options): Plugin<ComponentDoc[]>;

export { type Options, plugin as default };
